FatMouse's Speed--hdu1160(dp+输出路径)

Problem Description

FatMouse believes that the fatter a mouse is, the faster it runs. To disprove this, you want to take the data on a collection of mice and put as large a subset of this data as possible into a sequence so that the weights are increasing, but the speeds are decreasing.

Input

Input contains data for a bunch of mice, one mouse per line, terminated by end of file.

The data for a particular mouse will consist of a pair of integers: the first representing its size in grams and the second representing its speed in centimeters per second. Both integers are between 1 and 10000. The data in each test case will contain information for at most 1000 mice.

Two mice may have the same weight, the same speed, or even the same weight and speed.

Output

Your program should output a sequence of lines of data; the first line should contain a number n; the remaining n lines should each contain a single positive integer (each one representing a mouse). If these n integers are m[1], m[2],..., m[n] then it must be the case that

W[m[1]] < W[m[2]] < ... < W[m[n]]

and

S[m[1]] > S[m[2]] > ... > S[m[n]]

In order for the answer to be correct, n should be as large as possible.
All inequalities are strict: weights must be strictly increasing, and speeds must be strictly decreasing. There may be many correct outputs for a given input, your program only needs to find one.

Sample Input

6008 1300

6000 2100

500 2000

1000 4000

1100 3000

6000 2000

8000 1400

6000 1200

2000 1900

Sample Output

4

4

5

9

7

题目大意:
这是个大英文题啊

他给你老鼠的体重和奔跑的速度

然后当体重呈升序的时候   速度的最长下降序列

这都不重要   重要的是还要打印路径

分析:

就是先对体重排序

然后求最长下降序列

再求的过程中记录路径   最后输出

#include<stdio.h>
#include<string.h>
#include<math.h>
#include<algorithm>
#include<iostream>
#include<math.h>
#include<stdlib.h>

using namespace std;

#define INF 0xfffffff
#define N 5000

struct node
{
    int num,w,s;
}a[N];

int cmp(const void *x,const void *y)
{
    struct node *c,*d;
    c=(struct node *)x;
    d=(struct node *)y;
    if(c->w!=d->w)
    return c->w-d->w;
    else
        return d->s-c->s;
}
int main()
{
    int i=0,pre[N],dp[N];
    while(scanf("%d %d",&a[i].w,&a[i].s)!=EOF)
    {
        dp[i]=1;
        pre[i]=0;
        a[i].num=i+1;
        i++;
    }
    int n=i,b,Max=0;
    qsort(a,n,sizeof(a[0]),cmp);
    for(i=0;i<n;i++)
    {
        for(int j=0;j<i;j++)
        {
            if(a[j].w<a[i].w&&a[j].s>a[i].s&&dp[j]+1>dp[i])
            {
                dp[i]=dp[j]+1;
                pre[i]=j;
                if(Max<dp[i])
                {
                    b=i;
                    Max=dp[i];
                }
            }
        }
    }
    int aa[N];
    printf("%d\n",Max);
    aa[0]=a[b].num;
    i=1;
    while(1)
    {
        int j=pre[b];
        if(j==0)
            break;
        aa[i++]=a[j].num;
        b=j;
    }
    for(int j=i-1;j>=0;j--)
        printf("%d\n",aa[j]);
    return 0;
}

FatMouse's Speed--hdu1160(dp+输出路径)

时间: 2024-11-03 04:15:24

FatMouse's Speed--hdu1160(dp+输出路径)的相关文章

FatMouse&#39;s Speed(HDU-1160)

一道经典的最长子序列题,不过该题需要维护两个量,体重和速度,所以需要先对一个量进行排序,然后剩下的那个量就可以像处理最长子序列那样做了. 值得一提的是该题需要打印路径,最好的方法是用一个数组pre运用类似链表的结构,来记录路径. 这恰恰就是紫书上数据结构那章例题14中所用的记录最短路路径的方法 . 其中的巧妙和实现细节请读者细细品味. 针对这道题, 由于dp是利用之前计算的结果进行递推得到的,因此,每一步的计算都要用到上一步的结.最长上升子序列,就是枚举当前序列的最后一位,然后从前面递推找最优解

HDU 1160 FatMouse&#39;s Speed 简单DP

FatMouse's Speed Problem Description FatMouse believes that the fatter a mouse is, the faster it runs. To disprove this, you want to take the data on a collection of mice and put as large a subset of this data as possible into a sequence so that the

HDU 1160 FatMouse&#39;s Speed (sort + dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1160 给你一些老鼠的体重和速度,问你最多需要几只可以证明体重越重速度越慢,并输出任意一组答案. 结构体按照体重从小到大排序,然后根据速度就是最长下降子序列. 1 //#pragma comment(linker, "/STACK:102400000, 102400000") 2 #include <algorithm> 3 #include <iostream> 4

【HDU】 1160 FatMouse&#39;s Speed (DP)

一开始写的dfs进行记忆化结果不知道怎么进行路径的记录...改成循环就好了 dp[i] = max(dp[j]) + 1 , weight[j] < weight[j] && speed[j] > speed[i] 一开始进行一次排序使得重量递增,这样只需要考虑速度就好了 #include<cstdio> #include<algorithm> using namespace std; const int maxn = 10005; struct Mou

uva 11578 - Situp Benches(dp+输出路径)

题目连接:uva 11578 - Situp Benches 题目大意:健身房有两个仪器,初始角度为10度,每次有人使用需要交15元,每调10度需要花费10元,现在有n个人,给出每个人使用仪器的顺序和角度,保证不会同时有大于2个人序号一样,求最小花费,并且输出每个人分别使用哪一个仪器,并且所有人使用结束后,要将仪器调回10度. 解题思路:dp[i][x][y]表示第i个人,一个仪器为x,另一个仪器为y的情况,path[i][x][y]记录的是它的前一个状态,[0]为前一个仪器的夹角,[1]为另一

[HDOJ1160]FatMouse&#39;s Speed(DP)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1160 FatMouse believes that the fatter a mouse is, the faster it runs. To disprove this, you want to take the data on a collection of mice and put as large a subset of this data as possible into a sequen

FatMouse&#39;s Speed 基础DP

FatMouse's Speed Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 13643    Accepted Submission(s): 6011Special Judge Problem Description FatMouse believes that the fatter a mouse is, the faster i

URAL 1900. Brainwashing Device(dp+输出路径)

1900. Brainwashing Device Time limit: 1.0 second Memory limit: 64 MB While some people travel in space from planet to planet and discover new worlds, the others who live on Earth still have to get up in the morning, go to work, return back home and t

CF864 E DP 输出路径

n个物品有Deadline,拿物品需要花费时间,问取得最大价值的方案. 本质是个01背包,先按时间排序,然后把花费的时间作为背包就行了. 主要就是找方案,倒过来找发生转移的就行了. 太菜了真的不会打CF,每次都要掉分 /** @Date : 2017-09-25 22:28:30 * @FileName: E.cpp * @Platform: Windows * @Author : Lweleth ([email protected]) * @Link : https://github.com/